
; BIOS fuer CPD2

		TITLE	CPD2BIOS

		.Z80


; Schalterverwaltung
testausgabe		EQU	0

; Schalterverwaltung
zwei_conout		EQU	1


; **********************************************************
;                   BIOS Sprungvektoren
; **********************************************************




             ; IM FOLGENDEN STEHEN DIE 17 VON CPM DEFINIERTEN
             ; SPRUNGVEKTOREN ZU DEN EINZELNEN EIN-/AUSGABE-
             ; FUNKTIONEN UND DISKETTEN-ROUTINEN

		JP	CBOOT		; (00) Kaltstartroutine
WBOOTE:		JP	WBOOT		; (01) Warmstartroutine
		JP	CONST		; (02) CONSOLE-Status abfragen
		JP	CONIN		; (03) CONSOLE-Eingabe
		JP	CONOUT		; (04) CONSOLE-Ausgabe
		JP	LIST		; (05) LIST-Ausgabe
		JP	PUNCH		; (06) PUNCH-Ausgabe
		JP	READER		; (07) READER-Eingabe
		JP	HOME		; (08) Spur Null einstellen
		JP	SELDSK		; (09) Laufwerk auswhlen
		JP	SETTRK		; (10) Spur auswhlen
		JP	SETSEC		; (11) Sektor auswhlen
		JP	SETDMA		; (12) Datenpufferadresse setzen
		JP	READ		; (13) Selektierten Sektor lesen
		JP	WRITE		; (14) Selektierten Sektor schreiben
		JP	LISTST		; (15) LIST-Status abfragen
		JP	SECTRAN		; (16) Umrechnen Sektornumme




; **********************************************************
;                   MONITOR Speicherzellen
; **********************************************************


VAR_SECNT:	DB	0		; Anzahl der Sektoren fuer das BOOT-File
ROMBANK:	DB	00H		; Speicherstelle fuer die ROM-BANK 



ZK_START:
		DB	0CH		; Clear Screen
		DB	'CP/M 2.2 Copyright 1979 (c) by Digital Research',0DH,0AH
		DB	'BIOS-Monitor 2011 written by Ronald Daleske',0DH,0AH,0DH,0AH,0

ZK_EINGABE:
		DB	"Zeichen=",0

ZK_CRLF:	
		DB	0DH,0AH,0

ZK_ANZ_SE:
		DB	0DH,0AH,"Anzahl der Sektoren der BOOT-Datei=",0


ZK_Sektor:
		DB	"Sektor=",0

ZK_Spur:
		DB	0DH,0AH,"Spur=",0

ZK_LW:
		DB	0DH,0AH,"Laufwerk=",0

ZK_S:
		DB	"S=",0

ZK_T:
		DB	" T=",0

ZK_B:
		DB	" B=",0

ZK_A:
		DB	" A=",0





; **********************************************************
;                   BIOS Speicherzellen und Texte
; **********************************************************

SECTOR:		DB	00H		; Sektor
TRACK:		DW	0002H		; Spur
DISKNO:		DB	00H		; Laufwerksnummer
DMAAD:		DW	80H		; DMA-Adresse


STACK_PUFF:	DW	0

ANZ_LW		EQU	2		; Anzahl der Laufwerke (von 1 beginnend)



DPH:

;Diskettenparameterkopf (DPH0)
; fuer die serielle Festplatte (ueber RS232)
;
DPH0:		DW	0		;Adresse der Konvertierungs-
					;tabelle (hier 0000H)
		DW	4		;Notizspeicher fuer das BDOS
					; (gesammt = 6 Byte)
		DW	4
		
		DW	80H
		
		;
		DW	DIRBUFF		;Adresse eines 128 Byte grossen
					;Puffers fuer die Arbeit mit 
					;dem Inhaltsverzeichnis
		DW	DPB0		;Adresse des Diskettenpara-
					;meterblockes
		DW	CSV0		;Adresse eines Notizspeichers
					;fuer die softwaremaessige 
					;Erkennung des Diskettenwechsels
		DW	ALV0		;Adresse eines Notizspeichers
					;fuer die Belegungsinformation



;Diskettenparameterkopf (DPH1)
; fuer die ROM-FLOPPY (FLASH)
;
DPH1:		DW	0		;Adresse der Konvertierungs-
					;tabelle (hier 0000H)
		DW	4		;Notizspeicher fuer das BDOS
					; (gesammt = 6 Byte)
		DW	4
		
		DW	80H
		
		;
		DW	DIRBUFF		;Adresse eines 128 Byte grossen
					;Puffers fuer die Arbeit mit 
					;dem Inhaltsverzeichnis
		DW	DPB1		;Adresse des Diskettenpara-
					;meterblockes
		DW	CSV1		;Adresse eines Notizspeichers
					;fuer die softwaremaessige 
					;Erkennung des Diskettenwechsels
		DW	ALV1		;Adresse eines Notizspeichers
					;fuer die Belegungsinformation




; Disketten Parameter Block (DPB0)
; ===============================
; fuer die serielle Festplatte (ueber RS232)
;
; spt=72,bsh=4,blm=15,exm=0,dsm=710,drm=255,al0=0f0h,al1=0,cks=64,off=2
;
DPB0:
; Number of 128-byte records per track
spt0:		DW	72		;Anzahl der Sektoren auf einer Spur 

; Block shift. 3 => 1k, 4 => 2k, 5 => 4k....
bsh0:		DB	4		;Blockverschiebungsfaktor
					;= LOG2(Blockgroesse/128)
					; LOG2 = Logarithmus zur Basis 2
					; LOG2(2048/128) = 4

; Block mask. 7 => 1k, 0Fh => 2k, 1Fh => 4k...
blm0:		DB	15		;Blockmaske = Anzahl der Sekto-
					;ren pro Block - 1
					;BLM = (2^BSH)-1
; Extent mask, see later
exm0:		DB	0		;Extentmaske

; (no. of blocks on the disc)-1
dsm0:		DW	710		;Anzahl der Bloecke pro Diskette minus 1
					;(einschliesslich des Verzeich-
	 				; nisses aber ohne Systemspuren)
; (no. of directory entries)-1
drm0:		DW	255		;max. Anzahl der Eintraege im 
					;Inhaltsverzeichnis - 1 = 256 - 1
; Directory allocation bitmap, first byte
al00:		DB	0f0h		;reservierten Eintraege fuer das
					;Inhaltsverzeichnis = 4 Blocke
; Directory allocation bitmap, first byte
AL10:		DB	00000000B	

; Checksum vector size, 0 or 8000h for a fixed disc.
;No. directory entries/4, rounded up.
cks0:		DW	64		;Laenge des Diskettenpuffervektors
					;tors = (DRM+1)/4 = (255+1)/4 = 64

; Offset, number of reserved tracks
off0:		DW	2		;Anzahl der reservierten Spuren
					;am Anfang der Diskette = 2

		DS	8



; Disketten Parameter Block (DPB1)
; ===============================
; fuer die ROM-FLOPPY (FLASH)
;
; spt=72,bsh=4,blm=15,exm=0,dsm=710,drm=255,al0=0f0h,al1=0,cks=64,off=2
;
DPB1:
; Number of 128-byte records per track
spt1:		DW	72		;Anzahl der Sektoren auf einer Spur 

; Block shift. 3 => 1k, 4 => 2k, 5 => 4k....
bsh1:		DB	4		;Blockverschiebungsfaktor
					;= LOG2(Blockgroesse/128)
					; LOG2 = Logarithmus zur Basis 2
					; LOG2(2048/128) = 4

; Block mask. 7 => 1k, 0Fh => 2k, 1Fh => 4k...
blm1:		DB	15		;Blockmaske = Anzahl der Sekto-
					;ren pro Block - 1
					;BLM = (2^BSH)-1
; Extent mask, see later
exm1:		DB	0		;Extentmaske

; (no. of blocks on the disc)-1
dsm1:		DW	710		;Anzahl der Bloecke pro Diskette minus 1
					;(einschliesslich des Verzeich-
	 				; nisses aber ohne Systemspuren)
; (no. of directory entries)-1
drm1:		DW	255		;max. Anzahl der Eintraege im 
					;Inhaltsverzeichnis - 1 = 256 - 1
; Directory allocation bitmap, first byte
al01:		DB	0f0h		;reservierten Eintraege fuer das
					;Inhaltsverzeichnis = 4 Blocke
; Directory allocation bitmap, first byte
AL11:		DB	00000000B	

; Checksum vector size, 0 or 8000h for a fixed disc.
;No. directory entries/4, rounded up.
cks1:		DW	64		;Laenge des Diskettenpuffervektors
					;tors = (DRM+1)/4 = (255+1)/4 = 64

; Offset, number of reserved tracks
off1:		DW	2		;Anzahl der reservierten Spuren
					;am Anfang der Diskette = 2

		DS	8







;BDOS - Notizspeicher
DIRBUFF:	DS	128,0		;IHV - Puffer
ALV0:		DS	128,0		;Belegungsvektor dsm/8
CSV0:		DS	64,0		;Pruefvektor 0
		;
ALV1:		DS	128,0		;Belegungsvektor dsm/8
CSV1:		DS	64,0		;Pruefvektor 0



		DS	32,0		; Ersatz




; **********************************************************
;                   BIOS Routinen
; **********************************************************






; *** CBOOT ***
; BIOS-Funktion (00) : Kaltstartroutine
; CBOOT, Cold BOOT : Kaltstart ausfhren
;
; Der Kaltstart wird nur nach dem erstmaligen Laden des Betriebsystems
; bentigt.
; Der Aufruf an den Kaltstart erfolgt meist von einem speziellen
; Ladeprogramm, das nach dem Einschalten des Rechners, das
; BIOS von der Systemdiskette geladen hat.
; Aufgabe des Kaltstart ist es, die einzelnen Systemkomponenten
; zu initialisieren und eine Meldung ber den erfolgten Systemstart
; auf der Console auszugeben.
; Falls der CCP und das BDOS bereits im Speicher stehen, kann
; nach dem Kaltstart sofort der CCP aktiviert werden. In diesem
; Fall mssen aber die beiden Sprungbefehle an den Adressen
; BOOT (nach BIOS+0003h) und BOOT+0005h (nach FBASE+OOO6h)
; eingesetzt sein. Normalerweise wird nach einem Kaltstart ein
; Warmstart ausgefhrt, der den CCP und das BDOS von der Diskette
; ldt und die Sprungbefehle einsetzt. Dann braucht nur
; die zuerst anzuwhlende Disk- und Usernummer in die Speicheradresse
; BOOT+0004h eingetragen zu werden.
;
; Aufruf: CBOOT
;
; Uebergabeparameter: keine
; Rueckgabeparameter: Sprung zum CCP oder bergang in die Warmstart-Funktion
;

CBOOT:		

		;
		LD	SP,STACK	;STACKPOINTER SETZEN
		;

		CALL	LINIT


		; Umschalten des Interface Transmission Protokoll (ITP) auf Schreiben (WR)
		CALL	INT_MODE_WR
		; Umschalten des Interface Transmission Protokoll (ITP) auf Lesen (RD)
		CALL	INT_MODE_RD
		;




		; Laden der Tabellenadressen
		LD	IX,D_ITP2_TAB
		LD	IY,C_ITP2_TAB
		LD	HL,RAM_CON_TAB
		;

		LD	A,D_ITP2_CON1
		LD	(IX),A

		LD	A,C_ITP2_CON1
		LD	(IY),A

		LD	A,D_ITP2_IW
		LD	(HL),A




		; Umschalten des Interface Transmission Protokoll (ITP) auf Lesen (RD)
		CALL	INT2_INIT_RD



;		LD	HL,ZK_ANZ_TP	; Anzeige des Kaltstarttextes
;		CALL	AUS_ZK
		;





		LD	HL,ZK_START	; Anzeige des Kaltstarttextes
		CALL	AUS_ZK
		;
		XOR	A         	;AKKU loeschen
		LD	(IOBYTE),A	;I/O-BYTE loeschen
		LD	(USERLW),A 	;LAUFWERK 0
		;
		LD	(RAM_D_SYS2),A	; Grundeinstellung fuer PIO 2 Port A
		LD	(ROMBANK),A		; ROMBANK=0






; (01) Warmstartroutine
WBOOT:
		;
		LD	SP,STACK	;STACKPOINTER SETZEN
		;
		; *** ROM einschalten ***
		; Umschalten der Speicherbank von RAM -> ROM
		XOR	A
		LD	(ROMBANK),A		; ROMBANK=0
		CALL	ROMSEL
		;
		; CCP von EEPROM laden
		;
		LD	HL,EEROMCCP	; CCP vom EEROM copieren
		LD	DE,CCPBASE
		LD	BC,CCPLEN
		LDIR
		;
		; BDOS von EEPROM laden
		;
		LD	HL,EEPROMBDOS	; BDOS vom EEROM copieren
		LD	DE,BDOSBASE
		LD	BC,BDOSLEN
		LDIR
		;
		; *** ROM abschalten ***
		; Umschalten der Speicherbank von ROM -> RAM
		CALL	RAMSEL


		;Parameter setzen und Sprung zum SCCP
		;
GOCPM:		LD	A,0C3H		;JP-OPCODE
		LD	(0),A		;fuer JP BWBOOT
		LD	HL,WBOOTE	;WBOOT-Eintrittspunkt
		LD	(1),HL		;Adressfeld setzen
		;
		LD	(5),A		;fuer JP BDOS
		LD	HL,SBDOS	;SBDOS-Eintrittspunkt
		LD	(6),HL		;Adressfeld setzen
		;
		LD	BC,80H		;Standard-DMA-Adresse
		CALL	SETDMA		;setzen
		;
		LD	A,(USERLW)	;momentanes Laufwerk
		LD	C,A		;in C uebergeben
		;
		JP	SCCP		;Sprung zum SCCP







; Initialisierung der Perepheriebausteine
;
BINIT:	LD	HL,BINITAB	;Adresse der Initialisierungs-
				;tabelle
	LD	B,1*(BINITAE-BINITAB)/2	;laenge der Initialisierungst.
	;
BINIT1:	LD	C,(HL)		;laden der neuen Geraeteadresse
	INC	HL		;naechstes Ausgabebyte
	OUTI			;Ausgabe von (HL) an Adresse C
				;danach: HL+1 , B-1
	JR	NZ,BINIT1
	;
	RET	


BINITAB:				;Initialisierungstabelle
	; Interruptsperre fuer alle Perepheriebausteine

	DB	PIO1AC		;PIO 1 A
	DB	3
	;
	DB	PIO1BC		;PIO 1 B
	DB	3
	;
	DB	PIO2AC		;PIO 2 A
	DB	3
	;
	DB	PIO2BC		;PIO 2 B
	DB	3
	;
	; --- Initialisierung der PIO2 Port A
	;
	; vor dem Freischalten der Ausgaenge wird das Ausgaberegister fuer
	; die Daten definiert gesetzt
	DB	PIO2AD
	DB	PIO2ADAR
	;
	; MODE3 Bitbetrieb (Maske folgt)
	DB	PIO2AC
	DB	0CFH
	;
	; Maske fuer Bitbetrieb PIO2 Port A
	; Bitmaske Port A - Initialisierung
	; A0 = A15    = 0 - Ausgang
	; A1 = A16    = 0 - Ausgang
	; A2 = A17    = 0 - Ausgang
	; A3 = A18    = 0 - Ausgang 
	; A4 = DAC_P1 = 1 - Eingang
	; A5 = DES_P1 = 0 - Ausgang
	; A6 = DAT_P1 = 0 - Ausgang
	; A7 = N.N.   = 1 - Eingang
	DB	PIO2AC
	DB	10010000B
	;
	; Setzen des Ausgaberegister -> definierter Pegel fuer die Steuerleitungen
	DB	PIO2AD
	DB	PIO2ADAR
	;
	; --- Initialisierung der PIO2 Port B
	;
	; MODE3 Bitbetrieb (Maske folgt)
	DB	PIO2BC
	DB	0CFH
	;
	; Maske fuer Bitbetrieb Port A (Daten - alles Eingaenge)
	DB	PIO2BC
	DB	BITMSKAE
	;
BINITAE:	
;


; ***** ENDE Initialisierung der Hardware *****






; *** CONST ***
; BIOS-Funktion (02) : CONSOLE-Status abfragen
; CONST: Status der Eingabeschnittstelle. Wurde ein Zeichen eingegeben,
; so wird im Register A der Wert OFFH bergeben, sonst 0. 
; Das Zeichen wird aber noch nicht eingelesen.
; Diese BIOS-Funktion wird vom BDOS bei jeder Zeichenausgabe
; zur Erkennung der Steuerzeichen CTRL-S und CTRL-C aufgerufen.
; Aufruf: CONST
; Uebergabeparameter: keine
; Rueckgabeparameter: Register A = 000H -> kein Zeichen
;                     Register A = 0FFH -> Zeichen vorhanden
;
CONST:
		; Umschalten des Interface Transmission Protokoll (ITP) auf Schreiben (WR)
		CALL	INT_MODE_WR
		;
		LD	B,RE_CONST
		CALL	ITP_SEND_01
		;
		; Umschalten des Interface Transmission Protokoll (ITP) auf Lesen (RD)
		CALL	INT_MODE_RD
		;
		CALL	ITP_RECEIVE_01		; Abholen der Daten, Ergebnis in A
		;
		RET



; *** CONIN ***
; BIOS-Funktion (03) : CONSOLE-Eingabe
; CONIN: A = Zeichen von der Console
; Diese Routine holt ein Zeichen von der Console (Tastatur) und
; gibt es im A-Register zurck. Falls kein Zeichen von der
; Console ansteht, mu auf ein Zeichen gewartet werden.
; Aufruf: CONIN
; Uebergabeparameter: keine
; Rueckgabeparameter: Register A = Zeichen von der Console
;    
CONIN:
		; Umschalten des Interface Transmission Protokoll (ITP) auf Schreiben (WR)
		CALL	INT_MODE_WR
		;
		LD	B,RE_CONIN
		CALL	ITP_SEND_01
		;
		; Umschalten des Interface Transmission Protokoll (ITP) auf Lesen (RD)
		CALL	INT_MODE_RD
		;
		CALL	ITP_RECEIVE_01		; Abholen der Daten, Ergebnis in A
		;
		CP	0
		JR	Z,CONIN
		;
		RET



; *** CONOUT ***
; BIOS-Funktion (04) : CONSOLE-Ausgabe
; CONOUT (CONsole OUTput) : Zeichen zur Console ausgeben, 
; Der im Register C befindliche Wert wird zur Console (Bildschirm) ausgegeben.
; Aufruf: CONOUT
; Uebergabeparameter: Register C = Zeichen im ASCII-Code
; Rueckgabeparameter: keine
;   




if	zwei_conout
  
CONOUT:


;		LD	(STACK_PUFF), SP
;		LD	SP,STACK2	;STACKPOINTER SETZEN



		push	ix
		push	iy



		PUSH	BC		; Retten des Zeichens in C
		PUSH	BC




		; Umschalten des Interface Transmission Protokoll (ITP) auf Schreiben (WR)
		CALL	INT_MODE_WR
		;
		LD	B,SE_CONOUT
		CALL	ITP_SEND_01
		;
		POP	BC
		LD	B,C
		CALL	ITP_SEND_01
		;




		
		; Umschalten des Interface Transmission Protokoll (ITP2) auf Schreiben (WR)
		CALL	INT2_MODE_WR
		;
		LD	B,SE_CONOUT
		CALL	ITP2_SEND_01
		;
		POP	BC
		LD	B,C
		CALL	ITP2_SEND_01
		;
		CALL	INT2_MODE_RD



		pop	iy
		pop	ix



;		LD SP, (STACK_PUFF)



		;
		RET




else


 
CONOUT:
		PUSH	BC		; Retten des Zeichens in C

		; Umschalten des Interface Transmission Protokoll (ITP) auf Schreiben (WR)
		CALL	INT_MODE_WR
		;
		LD	B,SE_CONOUT
		CALL	ITP_SEND_01
		;
		POP	BC
		LD	B,C
		CALL	ITP_SEND_01
		;
		;
		RET


endif



; *** LIST ***
; BIOS-Funktion (05) : LIST-Ausgabe
; LIST (LIST output) : Zeichen zum 'List '-Kanal (Drucker) ausgeben 
; Wie Consolenausgabe, aber zum ' List ' -Kanal.
;
; Aufruf: LIST
; Uebergabeparameter: Register C = Zeichen im ASCII-Code
; Rueckgabeparameter: keine
;   
LIST:
		PUSH	BC		; Retten des Zeichens in C

		; Umschalten des Interface Transmission Protokoll (ITP) auf Schreiben (WR)
		CALL	INT_MODE_WR
		;
		LD	B,SE_LIST
		CALL	ITP_SEND_01
		;
		POP	BC
		LD	B,C
		CALL	ITP_SEND_01
		;
		RET





; *** PUNCH ***
; BIOS-Funktion (06) : PUNCH-Ausgabe
; PUNCH output : Zeichen zum ' Punch ' -Kanal ausgeben 
; Wie Consolenausgabe, aber zum ' Punch ' -Kanal
;
; Aufruf: PUNCH
; Uebergabeparameter: Register C = Zeichen im ASCII-Code
; Rueckgabeparameter: keine
;   
; *** derzeit noch nicht implementiert ***
PUNCH:
		RET





; *** READER ***
; BIOS-Funktion (07) : READER-Eingabe
; READER (READER input) : Zeichen vom ' Reader ' -Kanal holen 
; Wie Consoleneingabe , aber vom 'Reader ' -Kanal
;
; Aufruf: READER
; Uebergabeparameter: keine
; Rueckgabeparameter: Register A = Zeichen von der Console
;   
; *** derzeit noch nicht implementiert ***
READER:
		RET





; *** HOME ***
; BIOS-Funktion (08) : Spur Null einstellen
;
; Diese Funktion war bei lteren Laufwerken zur exakten
; Positionierung des Schreib/Lesekopfes gedacht.
; Da das BDOS vor jedem Diskzugriff die Spurnummer ber SETTRK
; anwhlt, ist HOHE bei neueren Laufwerken berflssig.
;
; Aufruf: HOME
; Uebergabeparameter: keine
; Rueckgabeparameter: keine
;   
HOME:
		LD	C,0
		CALL	SETTRK
		RET




; *** SELDSK ***
; BIOS-Funktion (09)   : Laufwerk auswhlen
; SELDSK (SELect DISK) : Das BIOS mu die im C-Register bergebene 
; Laufwerksnummer berprfen und, falls ein Laufwerk mit dieser Nummer 
; existiert, in HL die Adresse des zugehrigen DPH zurckgeben,
; Im CP/n ist nicht garantiert, da nach einem SELDSK-Aufruf
; auch tatschlich auf dieses Laufwerk zugegriffen wird.
; Vielmehr hat der SELDSK-Aufruf nur eine 'Anmeldefunktion',
; damit sich das BDOS auf das Laufwerk einstellen kann.
; Das BIOS mu die Laufwerksnummer aber intern speichern, da
; sich nachfolgende Diskzugriffe immer auf das zuletzt selektierte
; Laufwerk beziehen.
;
; Aufruf: SELDSK
;
; Uebergabeparameter: C   = Laufwerksnummer
;                         =  0 fr Laufwerk A:
;                           ...
;                         = 15 fr Laufwerk P:
;
;                     E,0 = Login-Bit
;                         = 0, falls das Laufwerk zum ersten Mal
;                           angewhlt wird
;                         = 1, falls das Laufwerk seit dem letzten
;                           Warmstart schonmal angewhlt wurde
;
; Rueckgabeparameter: HL -> DPH des Laufwerks
;                     HL = 0, falls das Laufwerk nicht existiert
;  
SELDSK:
		LD	HL,0		; Code bei Fehler
		LD	A,C
		CP	ANZ_LW		; Abfrage der maximalen Laufwerksnummer
		RET	NC		; RET wenn Laufwerk nicht vorhanden
		; Laufwerksnummer im erlaubten Bereich
		LD	(DISKNO),A
		; Parameterkopf-Adresse berechnen
		LD	L,A
		LD	H,0		; HL=Laufwerksnummer
		ADD	HL,HL		; *2
		ADD	HL,HL		; *4
		ADD	HL,HL		; *8
		ADD	HL,HL		; *16 (Kopf - Laenge)
		LD 	DE,DPH
		ADD	HL,DE		; HL = DPBASE (DISKNO*16)
		;
		RET





; *** SETTRK ***
; BIOS-Funktion (10) : Spurnummer auswhlen
; SETTRK (SET TRacK) : Der nchste Diskzugriff bezieht sich auf die im 
; Registerpaar BC bergebene Spur. Die so gesetzte Spurnummer, errechnet
; sich immer aus der BDOS-internen (logischen) Spurnummer plus dem OFF-Wert im DPB. 
; Wie auch beim SELDSK-Aufruf ist ein tatschlicher Diskzugriff nicht garantiert.
;
; Aufruf: SETTRK
;
; Uebergabeparameter: Register BC = Spurnummer
; Rueckgabeparameter: keine
;  
SETTRK:
		LD	(TRACK),BC
		;
		RET




; *** SETSEC ***
; BIOS-Funktion (11)  : Sektor auswhlen
; SETSEC (SET SECtor) : Logische Sektornummer setzen 
;
; Der nchste Diskzugriff bezieht sich auf den im Registerpaar
; BC bergebenen Sektor. Die so gesetzte Sektornummer ist immer
; das Ergebnis der SECTRAN-Funktion (s.u.). Auch hier ist ein
; tatschlicher Diskzugriff auf diesen Sektor nicht garantiert.
;
; Aufruf: SETSEC
;
; Uebergabeparameter: Register BC = Logische Sektornummer - Hier wird nur das niederwertige
;                                                           Byte (Reg.C) abgespeichert 
; Rueckgabeparameter: keine
;  
SETSEC:
		LD	A,C
		LD	(SECTOR),A
		;
		RET






; *** SETDMA ***
; BIOS-Funktion (12) : Datenpufferadresse setzen
;
; SETDMA (SET DMA-addresse) : Alle nachfolgenden Diskzugriffe
; mssen die DMA-Adresse als Quell- (bei Schreibzugriffen)
; bzw. Zieladresse (bei Lesezugriffen) benutzen.
; Die DMA-Adresse zeigt immer auf einen 128-Byte groen Buffer,
; weshalb Diskzugriffe immer in Recordgre erfolgen.
;
; Aufruf: SETDMA
;
; Uebergabeparameter: Register BC = DMA-Adresse
; Rueckgabeparameter: keine
;  
SETDMA:     
	LD	(DMAAD),BC
	;
	RET




; *** READ ***
; BIOS-Funktion (13) : Selektierten Sektor lesen
; READ, READ sector  : Logischen Sektor lesen
;
; Die READ-Funktion liest einen (logischen) Sektor von der Diskette 
; in den DMA-Buffer. Die Disknummer, Spurnummer und Sektornummer sind
; jeweils durch die letzten SELDSK-, SETTRKund SETSEC-Aufrufe festgelegt.
; Bei physikalischen Sektorlngen vom mehr als 128 Bytes, mu das BIOS einen 
; Sektorbuffer entsprechender Groe selbst bereitstellen und aus diesem Buffer, 
; 128 Bytes zum zuletzt definierten DMA-Buffer kopieren.
; Falls ein Lesefehler auftritt, sollte das BIOS den Diskzugriff
; ein paar Mal wiederholen und, falls der Fehler bestehen
; bleibt, den Fehlercode 1 im A-Register zurckgeben.
;
; Aufruf: READ
;
; Uebergabeparameter: keine
; Rueckgabeparameter: Register A = Fehlercode
;                                = 0, kein Fehler
;                                = 1, sonst
;  
READ:		
		LD	A,(DISKNO)
		CP	0
		JR	NZ,READ1
		;
		CALL	RD_IMG_SEK
		JR	READ2
		;
READ1:
		CALL	READ_RFL
		;
READ2:
		XOR	A		; kein Fehler
		;
		RET




; *** WRITE ***
; BIOS-Funktion (14)  : Selektierten Sektor schreiben
; WRITE (WRITE sector): Logischen Sektor schreiben
;
; Die WRITE-Funktion schreibt einen (logischen) Sektor vom DMABuffer
; auf die Diskette. Die Disknummer, Spurnummer und Sektornummer
; sind jeweils durch die letzten SELDSK-, SETTRK- und SETSEC-Aufrufe festgelegt.
; Bei physikalischen Sektorlngen von mehr als 128 Bytes, kann das Record-Flag
; zur Realisierung eines 'Blocking'-Algorithmus verwendet werden. 
; Bei einem normalen Schreibzugriff reicht es, den logischen Sektor nur in 
; den BIOS-internen Sektorbuffer zu bernehmen.
; Dies hat den Vorteil, da nachfolgende Schreibzugriffe auf den selben
; physikalischen Sektor, keinen Diskettenzugriff verlangen.
; Erst wenn der neue logische Sektor in einem anderen physikalsichen Sektor
; liegt, mu der Sektorbuffer auf die Diskette geschrieben werden.
; Directory-Schreibzugriffe sollten immer direkt auf die
; Diskette geleitet werden.
;
; Aufruf: WRITE
;
; Uebergabeparameter: Register C = Record-Flag
;                                = 0, bei einem normalen Schreibzugriff
;                                = 1, falls der logische Sektor ein Directory-Record ist 
;                                = 2, falls der logische Sektor der erste Sektor eines neuen Blocks ist
;
; Rueckgabeparameter: Register A = Fehlercode
;                                = 0, kein Fehler
;                                = 1, sonst
;  
WRITE:		
		LD	A,(DISKNO)
		CP	0
		JR	NZ,WRITE1
		;
		CALL	WR_IMG_SEK
		JR	WRITE2
		;
WRITE1:
		CALL	WRITE_RFL
		;
WRITE2:
		XOR	A		; kein Fehler
		;
		RET



; *** LISTST ***
; BIOS-Funktion (15) : LIST-Status abfragen
;
; LISTST (LIST output STatus) : Status der Druckerausgabe testen 
;
; LISTST wird vom BDOS nicht bentigt, sondern dient dem CP/M
; Hilfsprogramm 'DESPOOL1 den Status der Druckerausgabe zu
; bestimmen.
;
; Aufruf: LISTST
;
; Uebergabeparameter: keine
; Rueckgabeparameter: A = Druckerstatus
;                       = OOH, Drucker nicht bereit
;                       = FFH, Drucker frei
;  
LISTST:
		;
		LD	A,0FFH		; Drucker bereit
		;
		RET




; *** SECTRAN ***
; BIOS-Funktion (16) : Umrechnen Sektornummer
;
; SECTRAN (SECtor TRANslation) : Sektornummer aus der Sektor-Verschrnkungs-
;                                Tabelle holen 
;
; Das BDOS benutzt diese Funktion, um aus der im DPH angegebenen
; Sektor-Verschrnkungs-Tabelle die Sektornummer zu entnehmen.
; Im allgemeinen gengt es, einfach die im Registerpaar BC
; bergebene Sektornummer ins Registerpaar HL zu kopieren.
;
; Aufruf: LISTST
;
; Uebergabeparameter: Register BC = Logische Sektornummer
;                     Register DE -> Sektor-Verschrnkungs-Tabelle
;
; Rueckgabeparameter: Register HL = (Logische) Sektornummer aus der Tabelle
;  
SECTRAN:
		LD	H,B		; Laden von HL mit BC
		LD	L,C
		;
		RET




; **********************************************************









; Funktion: Lesen eines Sektors aus dem FLASH-ROM
;
; Aufruf: READ_RFL
; Uebergabeparameter: keine
; Rueckgabeparameter: keine
; 
READ_RFL:
		CALL	XLOCATE		;Berechnung der RAM-Adresse


if testausgabe
		PUSH	HL
		CALL	STBA_To_LIST
		POP	HL
endif

		;
		CALL	ROMSEL
		;
		LD	DE,ROMBUFFER
		LD	BC,128		;einen Sektor lesen
		LDIR	
		;
		CALL	RAMSEL
		;
		LD	HL,ROMBUFFER
		LD	DE,(DMAAD)
		LD	BC,128		;einen Sektor schreiben
		LDIR	
		;
		RET






; Berechnen der ROM-Adresse und der Speicherbank aus TRACK und SECTOR
;
; Uebergabeparameter: keine
; Rueckgabeparameter: HL = Adresse des ROM
;
; 76543210 76543210 76543210
; --------------------------
;      111 11111100 00000000
;      876 54321098 76543210
; --------------------------
;      BBB B                 = BANK
;           AAAAAAA AAAAAAAA = Adresse (Marke2)
;            SSSSSS SSSSSSSS = S=Sector*SPT/Track (Marke1)
;      SSS SSSSSSSS SSSRRRRR = S=Sector*SPT/Track und R=Record (Marke4)
;            BBBB            = BANK (Marke3)
;
XLOCATE:	
		LD	BC,(TRACK)	; laden der Spurnummer
		LD	B,C
		LD	DE,(spt1)	; SPT1 = 64
		LD	HL,0
		;
		XOR	A
		CP	B
		JR	Z,XLOCATE2	; TRACK*SPT
		;
XLOCATE1:	ADD	HL,DE
		DJNZ	XLOCATE1
		;
XLOCATE2:	LD	A,(SECTOR)
		LD	E,A
		ADD	HL,DE		; (TRACK*SPT)+SECTOR
		;
		LD	A,H
		LD	(ROMBANK),A	; Marke3
		;
		LD	B,7
		;
XLOCATE3:	SLA	L
		RL	H
		DJNZ	XLOCATE3	; Marke4
		;
		RES	7,H		; Marke2
		;
		RET




ROMBUFFER:
		DS	128





; Funktion: Schreiben eines Sektors in den FLASH-ROM
;
; Aufruf: WRITE_RFL
; Uebergabeparameter: keine
; Rueckgabeparameter: keine
; 
WRITE_RFL:
		;
		XOR	A		;Fehler = 0
		RET







; Funktion: ROM (FLASH) selektieren
;
; *** ROM (FLASH) einschalten, RAM abschalten ***
; Umschalten der Speicherbank von RAM -> ROM
;
; Aufruf: ROMSEL
; nur Register A und B werden veraendert
;
; Uebergabeparameter: keine
; Rueckgabeparameter: keine
; 
ROMSEL:
		LD	A,(ROMBANK)
		;
		AND	00001111B		; nur die Bits D0..D3 sind wichtig
		LD	B,A			; Retten der Speicherbank in Reg B
		;
		LD	A,(RAM_D_SYS2)
		AND	11110000B		; 0 setzen der letzten Speicherbank
		OR	B			; Uebernahme der Speicherbank in die Speicherzelle	
		OUT	(D_SYS2_PORT),A		; Ausgabe der neuenSpeicherbank
		LD	(RAM_D_SYS2),A		; Abspeichern der Speicherbank
		;
		LD	A,(RAM_D_SYS1)		; aktivieren des ROM (FLASH) mit der geforderten Speicherbank
		RES	BIT_RAMSEL,A
		OUT	(D_SYS1_PORT),A
		LD	(RAM_D_SYS1),A
		;
		RET





; Funktion: RAM selektieren
;
; *** RAM einschalten, ROM abschalten ***
; Umschalten der Speicherbank von ROM -> RAM
;
; Aufruf: RAMSEL
; nur Register A wird veraendert
;
; Uebergabeparameter: keine
; Rueckgabeparameter: keine
; 
RAMSEL:
		LD	A,(RAM_D_SYS1)
		SET	BIT_RAMSEL,A
		OUT	(D_SYS1_PORT),A
		LD	(RAM_D_SYS1),A
		;
		RET








if	testausgabe


; Funktion: Sektor, Track, Bank, Adresse anzeigen (an LIST) 
;
; Aufruf: STBA_To_LIST
; Uebergabeparameter: HL = Adresse
; Rueckgabeparameter: keine
; 
STBA_To_LIST:

		PUSH	HL
		PUSH	HL
		;
		LD	HL,ZK_S		; ZK_S
		CALL	AUS_ZK_LIST
		;
		LD	A,(SECTOR)
		CALL	ByteToLIST
		;
		LD	HL,ZK_T		; ZK_T
		CALL	AUS_ZK_LIST
		;
		LD	HL,(TRACK)
		CALL	WordToLIST
		;
		LD	HL,ZK_B		; ZK_B
		CALL	AUS_ZK_LIST
		;
		LD	A,(ROMBANK)
		CALL	ByteToLIST
		;
		LD	HL,ZK_A		; ZK_A
		CALL	AUS_ZK_LIST
		;
		POP	HL
		CALL	WordToCONOUT
		;
		LD	HL,ZK_CRLF	; Abschluss der Eingabezeile
		CALL	AUS_ZK_LIST
		;
		POP	HL
		CALL	ROMSEL
		CALL	SEKToLIST
		CALL	RAMSEL
		;
		RET




; Funktion: 1 Sektor ab Adresse HL anzeigen (an LIST) 
;
; Aufruf: SEKToLIST
; Uebergabeparameter: Register HL = Anfangsadresse der Bytewerte
; Rueckgabeparameter: Register HL = Ziel-Adresse fuer weitere Bytewerte
; 
SEKToLIST:
		LD	A,8
		;
SEKToLIST_1:
		PUSH	AF
		CALL	By16ToLIST
		;
		POP	AF
		;
		DEC	A
		JR	NZ,SEKToLIST_1
		;
		RET




; Funktion: 16 Byts ab Adresse HL anzeigen (an LIST) 
;
; Aufruf: By16ToLIST
; Uebergabeparameter: Register HL = Anfangsadresse der Bytewerte
; Rueckgabeparameter: Register HL = Ziel-Adresse fuer weitere Bytewerte
; 
By16ToLIST:
		PUSH	HL
		;
		CALL	WordToLIST
		;
		LD	C,','
		CALL	LIST
		;
		POP	HL
		LD	A,16
		;
By16ToLIST_1:
		PUSH	AF
		;
		LD	A,(HL)
		INC	HL
		PUSH	HL
		;
		CALL	ByteToLIST
		;
		LD	C,','
		CALL	LIST
		;
		POP	HL	
		POP	AF
		;
		DEC	A
		JR	NZ,By16ToLIST_1
		;
		PUSH	HL
		;
		LD	HL,ZK_CRLF	; Abschluss der Eingabezeile
		CALL	AUS_ZK_LIST
		;
		POP	HL
		;
		RET




; Funktion: WordToLIST
;
; Aufruf: WordToLIST
; Uebergabeparameter: Register HL - Wordwert
; Rueckgabeparameter: keine
; 
WordToLIST:
		CALL	WordToHex		
		;
		PUSH	DE
		PUSH	BC
		;
		LD	C,B
		CALL	LIST
		;
		POP	BC
		;
		CALL	LIST
		;
		POP	DE
		PUSH	DE
		;
		LD	C,D
		CALL	LIST
		;
		POP	DE
		;
		LD	C,E
		CALL	LIST
		;
		LD	C,'H'
		CALL	LIST
		;
		RET




; Funktion: ByteToLIST
;
; Aufruf: ByteToLIST
; Uebergabeparameter: Register A = Bytewert
; Rueckgabeparameter: keine
; 
ByteToLIST:
		CALL	ByteToHex
		PUSH	BC
		;
		LD	C,B
		CALL	LIST
		;
		POP	BC
		CALL	LIST
		;
		LD	C,'H'
		CALL	LIST
		;
		RET




; Funktion: Ausgabe einer Zeichenkette auf den Bildschirm
;
; Aufruf: AUS_ZK_LIST
; Uebergabeparameter: Register HL = Adresse der Zeichenkette 
;                     Ende = 00H
; Rueckgabeparameter: keine
; 
AUS_ZK_LIST:	LD	A,(HL)
		OR	A
		RET	Z		;RET wenn Zeichen = 0 ist
		LD	C,A
		PUSH	HL
		CALL	LIST		;Ausgabe des Zeichens in Reg.C
		POP	HL
		INC	HL
		;
		JR	AUS_ZK



endif










; Funktion: WordToCONOUT
;
; Aufruf: WordToCONOUT
; Uebergabeparameter: Register HL - Wordwert
; Rueckgabeparameter: keine
; 
WordToCONOUT:
		CALL	WordToHex		
		;
		PUSH	DE
		PUSH	BC
		;
		LD	C,B
		CALL	CONOUT
		;
		POP	BC
		;
		CALL	CONOUT
		;
		POP	DE
		PUSH	DE
		;
		LD	C,D
		CALL	CONOUT
		;
		POP	DE
		;
		LD	C,E
		CALL	CONOUT
		;
		LD	C,'H'
		CALL	CONOUT
		;
		RET


; Funktion: ByteToCONOUT
;
; Aufruf: ByteToCONOUT
; Uebergabeparameter: Register A = Bytewert
; Rueckgabeparameter: keine
; 
ByteToCONOUT:
		CALL	ByteToHex
		PUSH	BC
		;
		LD	C,B
		CALL	CONOUT
		;
		POP	BC
		CALL	CONOUT
		;
		LD	C,'H'
		CALL	CONOUT
		;
		RET
		



; Funktion: WordToHex
;
; Aufruf: WordToHex
; Uebergabeparameter: Register HL = Wordwert
; Rueckgabeparameter: Register BC und DE - ASCII-Zeichen des Wordwertes
; 
WordToHex:
		LD	A,H
		PUSH	HL
		;
		CALL	ByteToHex
		;
		POP	HL
		PUSH	BC
		;
		LD	A,L
		;
		CALL	ByteToHex
		;
		LD	D,B
		LD	E,C
		POP	BC
		;
		RET



; Funktion: ByteToHex
;
; Aufruf: ByteToHex
; Uebergabeparameter: Register A = Bytewert
; Rueckgabeparameter: Register BC - B = HWT, C = LWT
; 
ByteToHex:
		PUSH	AF
		AND	00FH
		;
		CALL	ByteToHex_A
		LD	C,A
		;
		POP	AF
		SRL	A
		SRL	A
		SRL	A
		SRL	A
		;
		CALL	ByteToHex_A
		LD	B,A
		;
		RET


ByteToHex_A:	ADD	A,'0'		; Zahl '0'
		CP	'9'+1		; '9'+1 -> 0..9 = Cyrry , A..F = not Curry
		RET	C
		;
		ADD	A,07		; 65D ('A') - 48D ('0') = 17D -> Differenz zw. '0' und 'A'
		;
		RET






; Funktion: Ausgabe einer Zeichenkette auf den Bildschirm
;
; Aufruf: AUS_ZK
; Uebergabeparameter: Register HL = Adresse der Zeichenkette 
;                     Ende = 00H
; Rueckgabeparameter: keine
; 
AUS_ZK:		LD	A,(HL)
		OR	A
		RET	Z		;RET wenn Zeichen = 0 ist
		LD	C,A
		PUSH	HL
		CALL	CONOUT		;Ausgabe des Zeichens in Reg.C
		POP	HL
		INC	HL
		;
		JR	AUS_ZK




; Funktion: Hin- und Herschalten der gelben LED
;
; Aufruf: TOGGLE_LED_GE
; Uebergabeparameter: keine
; Rueckgabeparameter: keine
; 
TOGGLE_LED_GE:	LD	A,(RAM_D_SYS1)
		OUT	(D_SYS1_PORT),A
		;	
		BIT	BIT_LED_GE,A
		JR	Z,TOGGLE_LED_GE_A
		;
		RES	BIT_LED_GE,A
		;
		JR	TOGGLE_LED_GE_B
		;
TOGGLE_LED_GE_A:
		SET	BIT_LED_GE,A
		;
TOGGLE_LED_GE_B:
		LD	(RAM_D_SYS1),A
		;
		RET





; Funktion: Hin- und Herschalten der gruenen LED
;
; Aufruf: TOGGLE_LED_GN
; Uebergabeparameter: keine
; Rueckgabeparameter: keine
; 
TOGGLE_LED_GN:	LD	A,(RAM_D_SYS1)
		OUT	(D_SYS1_PORT),A
		;	
		BIT	BIT_LED_GN,A
		JR	Z,TOGGLE_LED_GN_A
		;
		RES	BIT_LED_GN,A
		;
		JR	TOGGLE_LED_GN_B
		;
TOGGLE_LED_GN_A:
		SET	BIT_LED_GN,A
		;
TOGGLE_LED_GN_B:
		LD	(RAM_D_SYS1),A
		;
		RET








; Funktion: Zeitschleife von etwa 0,1 Sekunden
;
; Aufruf: WAIT_01S
; Uebergabeparameter: Register A - 1..255 in 100 mS
; Rueckgabeparameter: keine
; 
WAIT_01S_Fak	EQU	FRQ*354/10
;
WAIT_01S:	LD	C,WAIT_01S_Fak	; 7T
		;
WAIT_01S_B:	LD	B,254		; 7T
		;
WAIT_01S_C:	DEC	B		; 4T
		JR	NZ,WAIT_01S_C	; 7T / 12T / 11T*254=2794T+12T+7T=2813T
		;
		DEC	C		; 4T
		JR	NZ,WAIT_01S_B	; 7T / 12T / 2813T+11T=2824T*141=398184T+12T+7T=398203T
		;
		DEC	A
		JR	NZ,WAIT_01S

		RET



; **********************************************************
;  Basis-Routinen fr das ASI (Asynchron Serial Interface)
; **********************************************************


; Funktion: sendet ein Byte an die ASI-Schnnittstelle
;
; Aufruf: ASI_SEND_BYTE
; Uebergabeparameter: Register C - zu sendendes Byte
; Rueckgabeparameter: keine
; 
ASI_SEND_BYTE:	
		LD	A,(RAM_D_SYS1)
		SET	BIT_LED_RT,A
		OUT	(D_SYS1_PORT),A
		LD	(RAM_D_SYS1),A 
		;
		LD	B,8			; Zaehler in B mit 8 (Bit) laden
		;
		LD	A,(RAM_D_SYS2)	; in Register D wird die Grundeinstellung des Port A
		LD	D,A			; der PIO2 geladen
		;
ASI_SEND_BYTE_A:
		IN	A,(D_SYS2_PORT)		; Einlesen des Acknowledge-Bits 
		BIT	BIT_DAC_P1,A		; Testen des Acknowledge-Bits
		;
		JR	NZ,ASI_SEND_BYTE_A	; warten, bis der ATMEGA8 das Daten-Bit zurueck gesetzt hat
						; und dies durch Ruecksetzen der
						; Steuerleitung BIT_DAC_P1 bestaetigen
		; geht was am ATMEGA8 schief (keine Bestaetigung d.h.
		; Endlosschleife), dann bleibt die rote LED eingeschaltet
		;
		RRC	C			; Datenbit von Register C -> Curry
		SET	BIT_DAT_P1,A		; pauschales Setzen des Datenbits (BIT_DAT_P1) 
		;
		JR	C,ASI_SEND_BYTE_B	; war C wirklich 1, so bleibt es dabei ...
		;
		RES	BIT_DAT_P1,A		; ... ansonstens wird das Datenbit (BIT_DAT_P1) zurueck gesetzt
		;
ASI_SEND_BYTE_B:
		;
		OUT	(D_SYS2_PORT),A		; Ausgabe des Datenbits (BIT_DAT_P1) 
		;
		SET	BIT_DES_P1,A		; setzen des Enable-Bits (BIT_DES_P1)
		OUT	(D_SYS2_PORT),A		; und Ausgabe 
		;
ASI_SEND_BYTE_C:		
		IN	A,(D_SYS2_PORT)		; Einlesen des Acknowledge-Bits 
		BIT	BIT_DAC_P1,A		; Testen des Acknowledge-Bits
		;
		JR	Z,ASI_SEND_BYTE_C	; warten, bis der ATMEGA8 das Daten-Bit uebernommen hat
						; und dies durch Setzen der
						; Steuerleitung BIT_DAC_P1 bestaetigen
		; geht was am ATMEGA8 schief (keine Bestaetigung d.h.
		; Endlosschleife), dann bleibt die rote LED eingeschaltet
		;
		LD	A,D
		RES	BIT_DES_P1,A
		OUT	(D_SYS2_PORT),A
		;
		DJNZ	ASI_SEND_BYTE_A		; (C-1) bis alle 8 Bit gesendet wurden
		;	
		; jetzt kann die rote LED wieder abgeschaltet werden
 		LD	A,(RAM_D_SYS1)
		RES	BIT_LED_RT,A
		OUT	(D_SYS1_PORT),A
		LD	(RAM_D_SYS1),A
		;
		RET















; **********************************************************
;  2.LEVEL-Routinen fuer das Interface Transmission Protokoll
; **********************************************************









; Funktion: Write Sektor der Image-Datei
;
; Aufruf: WR_IMG_SEK
; Uebergabeparameter: keine
; Rueckgabeparameter: keine
;  
WR_IMG_SEK:
		CALL	SEND_STD		; Senden von Sektor, Spur und Laufwerk
		;
		LD	HL,(DMAAD)
		LD	B,0
WR_IMG_SEK_A:
		PUSH	BC
		CALL	WR_IMG_SEA		; Write Sektor-Abschnitt der Image-Datei (DISK)
		;
		POP	BC
		INC	B
		LD	A,B
		CP	4
		;
		JR	NZ,WR_IMG_SEK_A
		;
		RET








; Funktion: Write Sektor-Abschnitt der Image-Datei (DISK)
;
; Aufruf: WR_IMG_SEA
; Uebergabeparameter: Register B = 0..7 - lfd. Nr. des 16er Blockes aus dem Sektor
;                     Register HL = Ziel-Adresse fuer den Sektor 
; Rueckgabeparameter: Register HL = Ziel-Adresse fuer weitere Sektoren
; 
WR_IMG_SEA:	; Register retten (Reihenfolge wichtig)
		PUSH	HL
		PUSH	BC
		;
		; Umschalten des Interface Transmission Protokoll (ITP) auf Schreiben (WR)
		CALL	INT_MODE_WR
		;
		; SE_WR_ISEC, lfdNr, D0, D1, ... DE, DF (32)  
		; 
		LD	B,SE_WR_ISEC
		CALL	ITP_SEND_01
		;
		POP	BC
		CALL	ITP_SEND_01		; Uebergabe lfd. Nr. des 16er Blockes aus dem Sektor 
		;
		POP	HL			; Ziel-Adresse fuer den Sektor
		LD	C,32
WR_IMG_SEA_A:
		LD	B,(HL)	
		INC	HL
		;
		PUSH	BC
		PUSH	HL
		;
		CALL	ITP_SEND_01		; Senden der Daten aus Register B
		;
		POP	HL
		POP	BC
		;
		DEC	C
		JR	NZ,WR_IMG_SEA_A
		;
		RET







; Funktion: Read Sektor der Image-Datei
;
; Aufruf: RD_IMG_SEK
; Uebergabeparameter: keine
; Rueckgabeparameter: keine
;  
RD_IMG_SEK:
		CALL	SEND_STD		; Senden von Sektor, Spur und Laufwerk
		;
		LD	HL,(DMAAD)
		LD	B,0
RD_IMG_SEK_A:
		PUSH	BC
		CALL	RD_IMG_SEA		; Read Sektor-Abschnitt der Image-Datei (DISK)
		;
		POP	BC
		INC	B
		LD	A,B
		CP	4
		;
		JR	NZ,RD_IMG_SEK_A
		;
		RET



; Funktion: Read Sektor-Abschnitt der Image-Datei (DISK)
;
; Aufruf: RD_IMG_SEA
; Uebergabeparameter: Register B = 0..7 - lfd. Nr. des 16er Blockes aus dem Sektor
;                     Register HL = Ziel-Adresse fuer den Sektor 
; Rueckgabeparameter: Register HL = Ziel-Adresse fuer weitere Sektoren
; 
RD_IMG_SEA:	; Register retten (Reihenfolge wichtig)
		PUSH	HL
		PUSH	BC
		;
		; Umschalten des Interface Transmission Protokoll (ITP) auf Schreiben (WR)
		CALL	INT_MODE_WR
		;
		; RE_RD_ISEC, lfdNr  
		; 
		LD	B,RE_RD_ISEC
		CALL	ITP_SEND_01
		;
		POP	BC
		CALL	ITP_SEND_01		; Uebergabe lfd. Nr. des 16er Blockes aus dem Sektor 
		;
		; Umschalten des Interface Transmission Protokoll (ITP) auf Lesen (RD)
		CALL	INT_MODE_RD
		;
		LD	B,32
		PUSH	BC
RD_IMG_SEA_A:
		CALL	ITP_RECEIVE_01		; Abholen der Daten, Ergebnis in A
		POP	BC
		POP	HL
		LD	(HL),A	
		INC	HL
		DEC	B
		JR	Z,RD_IMG_SEA_X
		;
		PUSH	HL
		PUSH	BC
		;
		JR	RD_IMG_SEA_A
		
RD_IMG_SEA_X:
		;
		RET




; Funktion: Senden von Sektor, Spur und Laufwerk (STD = Sector, Track and DISK) 
;
; Aufruf: SEND_STD
; Uebergabeparameter: keine
; Rueckgabeparameter: keine
; 
SEND_STD:	; Umschalten des Interface Transmission Protokoll (ITP) auf Schreiben (WR)
		CALL	INT_MODE_WR
		;
		; SE_STD, Sector, TrackHWT, TrackNWT, DISK  
		; 
		LD	B,SE_STD
		CALL	ITP_SEND_01
		;
		LD	A,(SECTOR)
		LD	B,A
		CALL	ITP_SEND_01		; Sector 
		;
		LD	BC,(TRACK)
		PUSH	BC
		CALL	ITP_SEND_01		; TrackHWT
		;
		POP	BC
		LD	B,C
		CALL	ITP_SEND_01		; TrackNWT
		;
		LD	A,(DISKNO)
		LD	B,A
		CALL	ITP_SEND_01		; DISK 
		;
		RET





; Funktion: Read Sector Count (Lesen der Anzahl der Sektoren)
;
; Aufruf: RD_SE_NR
; Uebergabeparameter: keine
; Rueckgabeparameter: Register A und Speicherzelle VAR_SECNT
; 
RD_SE_CNT:
		; Umschalten des Interface Transmission Protokoll (ITP) auf Schreiben (WR)
		CALL	INT_MODE_WR
		;
		LD	B,RE_SECNT
		CALL	ITP_SEND_01
		;
		; Umschalten des Interface Transmission Protokoll (ITP) auf Lesen (RD)
		CALL	INT_MODE_RD
		;
		CALL	ITP_RECEIVE_01		; Abholen der Daten, Ergebnis in A
		;
		LD	(VAR_SECNT),A
		;
		RET





; Funktion: Read BOOT File (Lesen der Anzahl der Sektoren)
;
; Aufruf: RD_BOOT_FILE
; Uebergabeparameter: keine
; Rueckgabeparameter: keine
; 
RD_BOOT_FILE:
		LD	C,0
		;
		LD	A,(VAR_SECNT)
		LD	B,A
		;
		LD	HL,TPA
			
RD_BOOT_FILE_1:
		PUSH	BC	
		CALL	RD_BOOT_SEK
		POP	BC
		;
		INC	C
		LD	A,B
		CP	C
		;
		JR	NZ,RD_BOOT_FILE_1
		;
		RET





; Funktion: Read BOOT Sektor (Lesen der Anzahl der Sektoren)
;
; Aufruf: RD_BOOT_SEK
; Uebergabeparameter: Register C = Nummer des zu lesenden Sektors (0..VAR_SECNT-1)
;                     Register HL = Ziel-Adresse fuer den Sektor 
; Rueckgabeparameter: Register HL = Ziel-Adresse fuer weitere Sektoren
;  
RD_BOOT_SEK:
		LD	B,0
RD_BOOT_SEK_A:
		PUSH	BC
		CALL	RD_BOOT_SEA
		;
		POP	BC
		INC	B
		LD	A,B
		CP	4
		;
		JR	NZ,RD_BOOT_SEK_A
		;
		RET





; Funktion: Read Sektor-Abschnitt der BOOT-Datei
;
; Aufruf: RD_BOOT_SEA
; Uebergabeparameter: Register B = 0..7 - lfd. Nr. des 16er Blockes aus dem Sektor
;                     Register C = Nummer des zu lesenden Sektors (0..VAR_SECNT-1)
;                     Register HL = Ziel-Adresse fuer den Sektor 
; Rueckgabeparameter: Register HL = Ziel-Adresse fuer weitere Sektoren
; 
RD_BOOT_SEA:	; Register retten (Reihenfolge wichtig)
		PUSH	HL
		PUSH	BC
		;
		; Umschalten des Interface Transmission Protokoll (ITP) auf Schreiben (WR)
		CALL	INT_MODE_WR
		;
		LD	B,RE_SECTOR
		CALL	ITP_SEND_01
		;
		POP	BC
		PUSH	BC
		CALL	ITP_SEND_01		; Uebergabe lfd. Nr. des 16er Blockes aus dem Sektor 
		;
		POP	BC
		LD	B,C
		CALL	ITP_SEND_01		; Uebergabe Nummer des zu lesenden Sektors 
		;
		; Umschalten des Interface Transmission Protokoll (ITP) auf Lesen (RD)
		CALL	INT_MODE_RD
		;
		LD	B,32
		PUSH	BC
RD_BOOT_SEA_A:
		CALL	ITP_RECEIVE_01		; Abholen der Daten, Ergebnis in A
		POP	BC
		POP	HL
		LD	(HL),A	
		INC	HL
		DEC	B
		JR	Z,RD_BOOT_SEA_X
		;
		PUSH	HL
		PUSH	BC
		;
		JR	RD_BOOT_SEA_A
		
RD_BOOT_SEA_X:
		;
		RET





